vsg: vsg::TextGroup Class Reference

vsg 1.1.9 VulkanSceneGraph library |

Loading...
Searching...
No Matches
Public Types | Public Member Functions | Static Public Member Functions | Public Attributes | List of all members
vsg::TextGroup Class Reference

`#include <TextGroup.h>`

Inheritance diagram for vsg::TextGroup:
[legend]
Collaboration diagram for vsg::TextGroup:
[legend]

## Public Types
using | Children = std::vector<ref_ptr<Text>, allocator_affinity_nodes<ref_ptr<Text>>>

## Public Member Functions
void | traverse (Visitor &visitor) override
void | traverse (ConstVisitor &visitor) const override
void | traverse (RecordTraversal &visitor) const override
int | compare (const Object &rhs) const override
| compare two objects, return -1 if this object is less than rhs, return 0 if it's equal, return 1 if rhs is greater,
void | read (Input &input) override
void | write (Output &output) const override
void | addChild (ref_ptr< Text > text)
virtual void | setup (uint32_t minimumAllocation=0, ref_ptr< const Options > options={})
Public Member Functions inherited from vsg::Inherit< vsg::Node, TextGroup >
| Inherit (Args &&... args)
std::size_t | sizeofObject () const noexcept override
const char * | className () const noexcept override
const std::type_info & | type_info () const noexcept override
bool | is_compatible (const std::type_info &type) const noexcept override
void | accept (Visitor &visitor) override
void | accept (ConstVisitor &visitor) const override
void | accept (RecordTraversal &visitor) const override
Public Member Functions inherited from vsg::Node
| Node (const Node &rhs, const CopyOp &copyop={})
ref_ptr< Object > | clone (const CopyOp &copyop={}) const override
Public Member Functions inherited from vsg::Inherit< Object, Node >
| Inherit (Args &&... args)
Public Member Functions inherited from vsg::Object
| Object (const Object &object, const CopyOp &copyop={})
Object & | operator= (const Object &)
template<class T>
T * | cast ()
template<class T>
const T * | cast () const
void | ref () const noexcept
void | unref () const noexcept
void | unref_nodelete () const noexcept
unsigned int | referenceCount () const noexcept
template<typename T>
void | setValue (const std::string &key, const T &value)
void | setValue (const std::string &key, const char *value)
| specialization of setValue to handle passing C strings
template<typename T>
bool | getValue (const std::string &key, T &value) const
| get specified value type, return false if value associated with key is not assigned or is not the correct type
void | setObject (const std::string &key, ref_ptr< Object > object)
| assign an Object associated with key
Object * | getObject (const std::string &key)
| get Object pointer associated with key, return nullptr if no object associated with key has been assigned
const Object * | getObject (const std::string &key) const
| get const Object pointer associated with key, return nullptr if no object associated with key has been assigned
template<class T>
T * | getObject (const std::string &key)
| get object pointer of specified type associated with key, return nullptr if no object associated with key has been assigned
template<class T>
const T * | getObject (const std::string &key) const
| get const object pointer of specified type associated with key, return nullptr if no object associated with key has been assigned
ref_ptr< Object > | getRefObject (const std::string &key)
| get ref_ptr<Object> associated with key, return nullptr if no object associated with key has been assigned
ref_ptr< const Object > | getRefObject (const std::string &key) const
| get ref_ptr<const Object> pointer associated with key, return nullptr if no object associated with key has been assigned
template<class T>
ref_ptr< T > | getRefObject (const std::string &key)
| get ref_ptr<T> of specified type associated with key, return nullptr if no object associated with key has been assigned
template<class T>
const ref_ptr< const T > | getRefObject (const std::string &key) const
| get ref_ptr<const T> of specified type associated with key, return nullptr if no object associated with key has been assigned
void | removeObject (const std::string &key)
| remove meta object or value associated with key
Auxiliary * | getOrCreateAuxiliary ()
Auxiliary * | getAuxiliary ()
const Auxiliary * | getAuxiliary () const

## Static Public Member Functions
template<class N, class V>
static void | t_traverse (N &node, V &visitor)
Static Public Member Functions inherited from vsg::Inherit< vsg::Node, TextGroup >
static ref_ptr< TextGroup > | create (Args &&... args)
static ref_ptr< TextGroup > | create_if (bool flag, Args &&... args)
Static Public Member Functions inherited from vsg::Node
static void * | operator new (std::size_t count)
| provide new and delete to enable custom memory management via the vsg::Allocator singleton, using the MEMORY_NODES_OBJECTS
static void | operator delete (void *ptr)
Static Public Member Functions inherited from vsg::Inherit< Object, Node >
static ref_ptr< Node > | create (Args &&... args)
static ref_ptr< Node > | create_if (bool flag, Args &&... args)
Static Public Member Functions inherited from vsg::Object
static ref_ptr< Object > | create ()
static ref_ptr< Object > | create_if (bool flag)
static void * | operator new (std::size_t count)
| provide new and delete to enable custom memory management via the vsg::Allocator singleton, using the MEMORY_AFFINTY_OBJECTS
static void | operator delete (void *ptr)

## Public Attributes
ref_ptr< Font > | font
ref_ptr< ShaderSet > | shaderSet
ref_ptr< TextTechnique > | technique
Children | children

## Additional Inherited Members
Protected Member Functions inherited from vsg::Object
virtual void | _attemptDelete () const
void | setAuxiliary (Auxiliary *auxiliary)

## Detailed Description

TextGroup node provides high performance rendering of large numbers of text labels, i.e. batched rendering of Text. In order to achieve batching all Text children of a TextGroup node use the same Font, ShaderSet and TextTechnique provided by the TextGroup node, any local Text entries for these are discarded. The individual Texts are positioned by their local TextLayout. TextGroup does not provide view frustum culling or level of detail, but you can add this if required by decorating the TextGroup with a CullNode/LOD and after TextGroup::setup() is called to initialize the rendering component, you can use the TextGroup->technique->extents() value to help set the CullNode/LOD.bounds value.

## Member Function Documentation

## ◆ compare()

int vsg::TextGroup::compare | ( | const Object & | rhs | ) | const
| overridevirtual

compare two objects, return -1 if this object is less than rhs, return 0 if it's equal, return 1 if rhs is greater,

Reimplemented from vsg::Inherit< vsg::Node, TextGroup >.

## ◆ read()

void vsg::TextGroup::read | ( | Input & | input | ) |
| overridevirtual

Reimplemented from vsg::Object.

## ◆ setup()

virtual void vsg::TextGroup::setup | ( | uint32_t | minimumAllocation = 0,
|  | ref_ptr< const Options > | options = {} )
| virtual

create the rendering backend. minimumAllocation provides a hint for the minimum number of glyphs to allocate space for.

## ◆ traverse() [1/3]

void vsg::TextGroup::traverse | ( | ConstVisitor & | visitor | ) | const
| inlineoverridevirtual

Reimplemented from vsg::Object.

## ◆ traverse() [2/3]

void vsg::TextGroup::traverse | ( | RecordTraversal & | visitor | ) | const
| inlineoverridevirtual

Reimplemented from vsg::Object.

## ◆ traverse() [3/3]

void vsg::TextGroup::traverse | ( | Visitor & | visitor | ) |
| inlineoverridevirtual

Reimplemented from vsg::Object.

## ◆ write()

void vsg::TextGroup::write | ( | Output & | output | ) | const
| overridevirtual

Reimplemented from vsg::Object.

The documentation for this class was generated from the following file:

- include/vsg/text/TextGroup.h